from subprocess import Popen, PIPE
import requests
import socket
import re
import platform
import requests.packages.urllib3.util.connection as urllib3_cn
 
def allowed_gai_family():
    family = socket.AF_INET    # force IPv4
    return family
 
urllib3_cn.allowed_gai_family = allowed_gai_family

# támogatott verziók
ANACONDA = ['4.10.3']
SLURM_JUPYTER = ['2.0.22']

codec = 'utf-8'

FILES = {
    'linux_init' : ['https://git.ik.bme.hu/joker/joker/raw/script/upgrade/files/__init__.py', '/lib/python3.8/site-packages/slurm_jupyter/__init__.py'],
    'win_init' : ['https://git.ik.bme.hu/joker/joker/raw/script/upgrade/files/win/__init__.py', '\Lib\site-packages\slurm_jupyter\__init__.py']
}

def anaconda():
    with Popen('conda --version', stdout=PIPE, stderr=PIPE, shell=True) as proc:
        (outdata, errdata) = proc.communicate()
        if errdata.decode(codec) != '':
            return False
        ver = outdata.decode(codec).split()
        print(f'\tAnaconda jelenlegi verzió: {ver[1]}')
        print(f'\tAnaconda ajánlott verziók: {ANACONDA}')
        return ver[1] in ANACONDA

def slurm():
    with Popen('conda list', stdout=PIPE, stderr=PIPE, shell=True) as proc:
        (outdata, errdata) = proc.communicate()
        if errdata.decode(codec) != '':
            return False, ''
        packages = outdata.decode(codec)
        res = re.search(r'slurm-jupyter \s*([\d.]+)', packages)
        ver = res.group(1)
        print(f'\tslurm-jupyter jelenlegi verzió: {ver}')
        print(f'\tslurm-jupyter ajánlott verziók: {SLURM_JUPYTER}')
        return ver in SLURM_JUPYTER

def path():
    with Popen('conda info', stdout=PIPE, stderr=PIPE, shell=True) as proc:
        (outdata, errdata) = proc.communicate()
        if errdata.decode(codec) != '':
            return False, ''
        path = outdata.decode(codec)
        res = re.search(r'base environment : (\S+)', path)
        path = res.group(1)
        return True, path

def getFile(dir, name):
    print(f'\tLetöltés: {FILES[name][0]}')
    print(f'\tA fájl ide kerül: {dir}{FILES[name][1]}')
    headers = {"User-Agent": "Mozilla/5.0 (X11; CrOS x86_64 12871.102.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.141 Safari/537.36"}
    req = requests.get(FILES[name][0], stream=True, headers=headers)
    print('\t', end =" ")
    with open(f'{dir}{FILES[name][1]}', 'wb') as f:
        for chunk in req.iter_content(chunk_size=256):
            if chunk:
                    f.write(chunk)
                    print('.', end ="")
    print('\n\tOK\n')

def files(dir):
    print('Fájlok letöltése')
    if platform.system() == 'Linux':
        getFile(dir, 'linux_init')
    elif platform.system() == 'Windows':
        getFile(dir, 'win_init')

def upgrade():
    print('Anaconda könyvtár keresése')
    ok, dir = path()
    if ok:
        print(f'\tKiolvasott útvonal: {dir}')
    else:
        print('\tNem tudtam útvonalat kiolvasni, adja meg: ')
        dir = input()
        print('Megpróbálom ezzel ...')
    files(dir)
    

if __name__ == '__main__':
    if platform.system() == 'Windows':
        codec = 'latin-1'
    print('Rendszer: ' + platform.platform())
    print("Anaconda vizsgálata ...")
    if anaconda() and slurm():
        print('OK\n')
        upgrade()
    else:
        print('Valami baj lehet! Folytatja (i/n) ?')
        ok = input()
        if ok == 'i' or ok == 'I':
            upgrade()
